<?php
/**
 * Created by PhpStorm.
 * User: tuliomagalhaes
 * Date: 10/03/2017
 * Time: 14:09
 */

namespace Service\Event;

use Doctrine\Common\EventSubscriber;
use Doctrine\ORM\Event\LifecycleEventArgs;
use Doctrine\ORM\Events;
use Teknisa\Model\Teknisa\Events\GeneratesNewCode;
use Teknisa\Model\Teknisa\Events\AlphanumericNewCode;
use Util\Utilities;

class AddNewCode implements EventSubscriber {

    public function prePersist(LifecycleEventArgs $args) {
        $entity = $args->getEntity();
        if ($entity instanceof GeneratesNewCode) {
            $tableName = Utilities::getTableName($entity);
            if($tableName == "CP_CALL"){
                $tableName = "CONTATO";
            }
            $nrorg = Utilities::getEnvironment()->getCurrentOrganizationId();
            if($entity instanceof AlphanumericNewCode){
                $newCode = Utilities::getAlphanumericCodeByTableName($tableName,$nrorg);
            }else{
                $newCode = Utilities::getCodeByTableName($tableName,$nrorg);
            }
            if ($newCode) {
                $entity->setPrimaryKeyInPersist($newCode);
                $entity->setNrorg($nrorg);
            }
        }
    }

    /**
     * Returns an array of events this subscriber wants to listen to.
     *
     * @return array
     */
    public function getSubscribedEvents() {
        return array(
            Events::prePersist,
        );
    }
} 