<?php
namespace Zeedhi\DevOps\Model\Projectmanagement\Repositories;

use Doctrine\ORM\EntityRepository;
use Zeedhi\DevOps\Model\Util\LogicalDeleted;
use Zeedhi\DevOps\Util\Utilities;

class BudgetPlots extends EntityRepository {

    public function findBudgetPlotsToDelete($budgetId,$lastParcel) {
        $query =
            <<<SQL
       SELECT  BPS.ID
        FROM BUDGET_PLOTS BPS
        WHERE BPS.BUDGET = :BUDGET_ID
        AND BPS.ORDER_PLOTS > :LAST_PARCEL
        
SQL;

        $params = array(
            "BUDGET_ID" => $budgetId,
            "LAST_PARCEL" => $lastParcel,
        );
        $result = $this->getEntityManager()->getConnection()->fetchAll($query, $params);
        $result = Utilities::getArrayFromArrayAssociative($result);
        return $result;
    }

}
